#!/bin/env perl -w

use strict;
use Getopt::Long;

GetOptions(
    'n' => \my $bynumber,
) or die "Wrong options given\n";
my ($serv, $proto) = @ARGV;
$proto or die "Usage: $0 [-n] SERVICE PROTOCOL\n";

open(my $handle, '<', '/etc/services')
    or die "Can't open services file: $!\n";

while (my $line = <$handle>) {
    chomp($line);
    $line =~ s/#.*//;
    my ($mname, $mport, $mproto) = $line =~ m:(\S+)\s+(\d+)/(\w+):
            or next;
    if ($bynumber) {
        if ($mport == $serv && $proto eq $mproto) {
            print "$mname\n"; exit(0);
        }
    } else {
        if ($mname eq $serv && $proto eq $mproto) {
            print "$mport\n"; exit(0);
        }
    }
}
close($handle);
die "Service $proto/$serv no found\n";
